public inbox for devel@edk2.groups.io
 help / color / mirror / Atom feed
* [RFC] edksetup.sh: detect updated BaseTools templates
@ 2016-09-04 15:41 Leif Lindholm
  2016-09-04 15:55 ` Ard Biesheuvel
  0 siblings, 1 reply; 8+ messages in thread
From: Leif Lindholm @ 2016-09-04 15:41 UTC (permalink / raw)
  To: edk2-devel; +Cc: Yonghong Zhu, Liming Gao, Ard Biesheuvel

Make edksetup.sh automatically update the cached configuration under
Conf/ when the templates under BaseTools/Conf/ change.

Contributed-under: TianoCore Contribution Agreement 1.0
Signed-off-by: Leif Lindholm <leif.lindholm@linaro.org>
---

We keep getting questions from people starting out with EDK2 development,
whenever certain options in the BaseTools template configs change and
their builds break. I don't know if this naive sledgehammer approach is
acceptable, but I'd like to make life easier for people.

 edksetup.sh | 33 +++++++++++++++++++++++++++++++--
 1 file changed, 31 insertions(+), 2 deletions(-)

diff --git a/edksetup.sh b/edksetup.sh
index 57368b5..77f0d43 100755
--- a/edksetup.sh
+++ b/edksetup.sh
@@ -33,12 +33,41 @@ function HelpMsg()
   return 1
 }
 
+function ClearCache()
+{
+  CONF_FILES="build_rule target tools_def"
+  if [ -z "$EDK_TOOLS_PATH" ]
+  then
+    TEMPLATE_PATH=./BaseTools/Conf/
+  else
+    TEMPLATE_PATH="$EDK_TOOLS_PATH/Conf/"
+  fi
+
+  DELETED_FILES=0
+  for File in $CONF_FILES
+  do
+    TEMPLATE_FILE="$TEMPLATE_PATH/$File.template"
+    CACHE_FILE="Conf/$File.txt"
+    if [ "$TEMPLATE_FILE" -nt "$CACHE_FILE" ]
+    then
+      echo "Removing outdated '$CACHE_FILE'."
+      rm "$CACHE_FILE"
+      DELETED_FILES=$(($DELETED_FILES + 1))
+    fi
+  done
+
+  unset TEMPLATE_PATH TEMPLATE_FILE CACHE_FILE
+  return $DELETED_FILES
+}
+
 function SetWorkspace()
 {
   #
-  # If WORKSPACE is already set, then we can return right now
+  # Check for updated BaseTools templates. If none, and
+  # WORKSPACE is already set, then we can return right now
   #
-  if [ -n "$WORKSPACE" ]
+  ClearCache
+  if [ $? -ne 0 -a -n "$WORKSPACE" ]
   then
     return 0
   fi
-- 
2.9.3



^ permalink raw reply related	[flat|nested] 8+ messages in thread

end of thread, other threads:[~2016-10-20  6:58 UTC | newest]

Thread overview: 8+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2016-09-04 15:41 [RFC] edksetup.sh: detect updated BaseTools templates Leif Lindholm
2016-09-04 15:55 ` Ard Biesheuvel
2016-09-04 16:10   ` Michael Zimmermann
2016-09-04 20:35     ` Ard Biesheuvel
2016-09-04 20:46       ` Michael Zimmermann
2016-10-19 12:21       ` Leif Lindholm
2016-10-20  6:58         ` Gao, Liming
2016-09-04 22:02     ` B Cran

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox